/* sclovar.cpp */

#include "stdio.h"
#include "io.h"
#include "slovar.h"

// #include <sys\types.h>
// #include <sys\stat.h>


  Vocab::Vocab(char *_fname)
  {  FILE *fp;
     char fnIndex[VD_MAXPATH], *ploc;
     char tmpName[VD_MAXPATH], tmpComment[VD_MAXPATH];
     int  flenWord, flenIndex, i, rc,  iWorddata;
     int  usecompresion;

    Error = 0;
    Busy = 0;
     strcpy(fname,_fname);

     strcpy(fnIndex,_fname);
     strcat(fnIndex,".bdx");
     n = 0;
     Worddata = NULL;

     rc = ReadIndex(fnIndex);
     if(rc)
     {  return;
     }

//     index = NULL;
//     Error = 1;
//     fp = fopen(fnIndex,"rb");
//     if(fp == NULL)
//        return;

//     Error = 11; // ⨬ ࠬ   䠩
//     rc = ReadVocHeader(fp,0, usecompresion, name, comment);
//     if(rc)
//     {   fclose(fp);
//         return;
//     }
//     flenIndex = _filelength(fileno(fp));
//     nn = (flenIndex - ( sizeof(struct VocHeader) + strlen(name) + strlen(comment)+2 ) )
//          / ( sizeof(class VocabIndex) - sizeof(char *) );
//     if(nn  < 1 )
//     {   fclose(fp);
//         return;
//     }
//     index = new VocabIndex[n];
//
//
//     Error = 3;  // 訡 ⥭
//     for(i = 0; i < n; i++)
//     {  rc = fread((void *)&index[i], sizeof(class VocabIndex) - sizeof(char *),1,fp);
//        if(rc != 1)
//            return;
//     }
//     fclose(fp);

//⠥ ᨢ ᫮
     strcpy(fnIndex,_fname);
     strcat(fnIndex,".wrd");

     rc = ReadWords(fnIndex);

//     Error = 1;
//     fp = fopen(fnIndex,"rb");
//     if(fp == NULL)
//        return;
//     rc = ReadVocHeader(fp,1, usecompresion, tmpName, tmpComment);
//     if(rc)
//     {   fclose(fp);
//         return;
//     }
//
//     flenWord = _filelength(fileno(fp)) - ftell(fp);
//     lenWorddata = flenWord+1;
//     Worddata = (char *) calloc(lenWorddata,1);
//     rc = fread(Worddata,flenWord,1,fp);
//     fclose(fp);
/* 砥 㪠⥫  (ᯫ譮) ᨢ ᫮ */
     iWorddata = 0;
     for(i = 0;i < n; i++)
     {
       // index[i].attr = 0; // 0
       index[i].word = &Worddata[iWorddata++];
       for( ;iWorddata < lenWorddata && Worddata[iWorddata]; iWorddata++);
       iWorddata++;
     }

     Error = 0;
     ploc = SlovarSetLocale(Locale);
     if(!ploc)
          Error = 10;    // can't set locale

  }

//   䠩 ᫮ -  type=0/1/2 - bdx/wrd/dat
int Vocab::WriteVocHeader(FILE *fp, int type, int usecompression, char *VocName, char *VocComment)
{
   struct VocHeader header;
   int i,rc;
   char * sTypes[3] = {VD_SIGNATURE_BDX,VD_SIGNATURE_WRD,VD_SIGNATURE_DAT};
   if(type < 0 || type > 2)
            return 4;  // ⨬ ࠬ
   memset(&header,0,sizeof(struct VocHeader));
   strcpy(header.signature,sTypes[type]);
   strcat(header.signature,VD_VERSION);
   strcat(header.signature,VD_SUBVERSION);
   header.n = n;
   header.usecompression = usecompression;
   header.CreationTime   = CreationTime;
   header.LastchangeTime = LastchangeTime;
   strcpy(header.LocaleName,Locale);
   strcpy(header.LocaleNameArticle,LocaleArticle);

   header.lName = 0;
   if(VocName)
   {      header.lName = strlen(VocName)+1;
          if(header.lName > VD_MAXPATH)
          {   header.lName = VD_MAXPATH;
              VocName[header.lName - 1] = 0;
          }
   }
   header.lComment = 0;
   if(VocComment)
   {     header.lComment = strlen(VocComment)+1;
         if(header.lComment > VD_MAXPATH)
          {   header.lComment = VD_MAXPATH;
              VocComment[header.lComment - 1] = 0;
          }
   }

   header.lHeader = sizeof(header) + header.lName + header.lComment;
// may include also sizeof(UsedDefinedData)

   rc = fwrite(&header, sizeof(header), 1, fp);
   if(rc != 1)
       return 2;  // 訡 
   if(header.lName)
   {   rc = fwrite(VocName, header.lName, 1, fp);
       if(rc != 1)
           return 2;  // 訡 
   }
   if(header.lComment)
   {  rc = fwrite(VocComment, header.lComment, 1, fp);
      if(rc != 1)
          return 2;  // 訡 
   }

   return 0;      // Ok
}

// ⥭  䠩 ᫮ -  type=0/1/2 - bdx/wrd/dat
int Vocab::ReadVocHeader(FILE *fp, int type, int &usecompression, char *VocName, char *VocComment)
{
   struct VocHeader header;
   char str[VD_MAXPATH];
   int rc, rc0=0;

   if(type < 0 || type > 2)
            return 4; // ⨬ ࠬ

   rc = fread(&header, sizeof(header), 1, fp);
   if(rc != 1)
       return 3; // 訡 ⥭
   if(header.n <= 0)
              return 8; // ⨬ ࠬ  

   strncpy(str,header.signature,2);
   str[2] = 0;
   if(strcmp(str,VD_SIGNATURE) )
        return 5; // ᮢ ᨣ
   str[2] = header.signature[2];
   str[3] = 0;
   switch(type)
   {   case 0:
        if(strcmp(str,VD_SIGNATURE_BDX) )
              return 6; // ᮢ ⨯  ᨣ
        n = header.n;
        CreationTime   = header.CreationTime;
        LastchangeTime = header.LastchangeTime;
         break;
       case 1:
        if(strcmp(str,VD_SIGNATURE_WRD) )
              return 6; // ᮢ ⨯  ᨣ
        if(n != header.n)
                 rc0 = 1; // ᮢ ⢠ ᥩ  ࠧ 䠩 ᫮
          break;
       case 2:
        if(strcmp(str,VD_SIGNATURE_DAT) )
              return 6; // ᮢ ⨯  ᨣ
        if(n != header.n)
                 rc0 = 1; // ᮢ ⢠ ᥩ  ࠧ 䠩 ᫮
          break;
   }
   strncpy(str,&header.signature[3],3);
   str[3] = 0;
//  㣠  ࠢ 
   if(strcmp(str,VD_VERSION ) )
              return 7; // ࠢ쭠 

   usecompression = header.usecompression;

   strcpy(Locale,header.LocaleName);

   if(header.lName > VD_MAXPATH || header.lName < 0 )
              return 8; // ⨬ ࠬ  
   if(header.lComment > VD_MAXPATH || header.lComment < 0)
              return 8; // ⨬ ࠬ  

   if(VocName)    VocName[0] = 0;
   if(VocComment) VocComment[0] = 0;
   if(header.lName)
   {   rc = fread(VocName, header.lName, 1, fp);
       if(rc != 1)
           return 3;  // 訡 ⥭
   }
   if(header.lComment)
   {   rc = fread(VocComment, header.lComment, 1, fp);
       if(rc != 1)
           return 3;  // 訡 ⥭
   }

// move to vocab start.

   if( ftell(fp) != header.lHeader)
            fseek(fp,header.lHeader,SEEK_SET);

   return 0;      // Ok
}
/*  ⥪ ᫮୮    article   int buflen
  ᫮  ᮬ ind
*/
int Vocab::GetArticle(int ind, char *article, int buflen)
{
   int l, rc=0,rc0, zero=0;
   FILE *fp;
   char filename[VD_MAXPATH];

   if(ind < 0 || ind >= n)
            return 1;
   if( article == NULL || buflen <= 0)
             return 1;
   article[0] = 0;

   l =  index[ind].l+1;
   if(l >= buflen)
   {    l = buflen-1;
        zero = 1;
   }
   strcpy(filename,fname);
   strcat(filename,".dat");
   fp = fopen(filename,"rb");
   if(fp == NULL)
      return 1;
   rc0 = fseek(fp,(long int) index[ind].pos,SEEK_SET);
//printf("index[%i].pos=%x (ftell=%x)\n ",ind,index[ind].pos, ftell(fp) );
   rc0 = fread(article, l, 1, fp);
   if(rc0 != 1) rc = 2;
   fclose(fp);
   if(zero)
       article[l] = 0;
   return rc;
}

/*    ᫮  word  p   article  buflen */
/* 頥 , 訡 -  Error */
int Vocab::GetArticle(char *word, char *article, int buflen)
{   int ind, rc;
    ind = Search(word);
    rc = GetArticle(ind, article, buflen);
    if(rc)
       Error = rc;
    return ind;
}

/*     ᫮ ᫮ */
int Vocab::Search(char *word)
{
    int low, high, mid, rc;
    int dist1, dist2;
    class VocabIndex key;
    Error = 0;
    key.pos = -1;
    key.word = word;
    low  = 0;
    high = n -1;
    while(low <= high)
    {   mid = (low + high) /2;
        rc = VocabSortCmp(&index[mid], &key);
        if(rc > 0)
               high = mid - 1;
        else
          if( rc < 0 )
               low = mid + 1;
        else
          return mid; /* found */
    }
    Error = 1;
    rc = VocabSortCmp(&index[mid], &key);
    if(rc > 0 && mid)
    {  dist1 = vb_Strcmp(index[mid-1].word, word);
       dist2 = vb_Strcmp(index[mid].word, word);
       if(dist1 < dist2)
                    mid--;
    } else
         if(rc < 0 && mid < n-1)
    {  dist1 = vb_Strcmp(index[mid].word, word);
       dist2 = vb_Strcmp(index[mid+1].word, word);
       if(dist1 > dist2)
                    mid++;
    }
    return mid;
}
/*  ᫮ ( ।⥫쭮 ஢) */
int Vocab::Save(void)
{
   int rc;
   char  filename[VD_MAXPATH];

 WaitBusy();
 SetBusy();

   SortIndex();

   LastchangeTime = time(NULL);

   strcpy(filename, fname);
   strcat(filename,".dat");
   rc = WriteImport(filename, "VDtmp");
   if(rc)
      return 1;
   remove(filename);
   rename("VDtmp.dat",filename);
   strcpy(filename, fname);
   strcat(filename,".bdx");
   remove(filename);
   rename("VDtmp.bdx",filename);
   strcpy(filename, fname);
   strcat(filename,".wrd");
   remove(filename);
   rename("VDtmp.wrd",filename);
 ReleaseBusy();
   return 0;
}

/*  ᫮  ᫮ */
int Vocab::Add(char *word, char *article)
{
    int i, j, ind, rc, indWord, l;
    class VocabIndex key;
    char  filename[VD_MAXPATH], *pstmp;
    FILE *fp;

    ind = Search(word);
    if(Error == 0)
           return 1; //㦥  ⠪ ᫮
 WaitBusy();
 SetBusy();


    key.pos = -1;
    key.word = word;
    rc = VocabSortCmp(&index[ind], &key);
    if(rc > 0 && ind) ind--;
/* ९뢠 ᨢ ᮢ */
    VocabIndex *indexNew = new VocabIndex[n+1];       // ᨢ  n+1
    for(i=n-1;i  > ind; i--) indexNew[i+1] = index[i];
    for(i=0;  i <= ind; i++)  indexNew[i]  = index[i];
    indexNew[ind+1] = key;
    delete [] index;
    index = indexNew;
    n++;  // 㢥稢 ᫮ ᫮
/* ९뢠   - ᫮ */
     lenWorddata += strlen(word)+1;
     char *WorddataNew = (char *) calloc(lenWorddata,1);    // pp뢭    p饭 n+1 ᫮

     indWord =0;
     for(i=0;i<= ind ;i++)
     {   l = strlen(index[i].word);
         pstmp = &WorddataNew[indWord];
          for(j = 0; j < l && indWord < lenWorddata ; j++)
                       WorddataNew[indWord++] = index[i].word[j];

          WorddataNew[indWord++] = 0;
          index[i].word = pstmp;
     }
     index[ind+1].word = &WorddataNew[indWord];
     l = strlen(word);
     for(j = 0; j < l && indWord < lenWorddata ; j++)
                       WorddataNew[indWord++] =  word[j];
     WorddataNew[indWord++] = 0;

     for(i=ind+2;i < n; i++)
     {   l = strlen(index[i].word);
         pstmp = &WorddataNew[indWord];
          for(j = 0; j < l && indWord < lenWorddata ; j++)
                       WorddataNew[indWord++] = index[i].word[j];

          WorddataNew[indWord++] = 0;
          index[i].word = pstmp;
     }
     free(Worddata);
     Worddata = WorddataNew;

// 뢠 ᫮   dat 䠩
     index[ind+1].l =  strlen(article);
     index[ind+1].attr = 0;
     strcpy(filename, fname);
     strcat(filename,".dat");
     fp = fopen(filename,"ab");
     index[ind+1].pos = ftell(fp);
     fwrite(article,index[ind+1].l+1,1,fp);
     fclose(fp);
 ReleaseBusy();

/*  ࠧ ࠭   ஢  */
     Save();

     return 0;
}

/* 㤠 ᫮ ind */
int Vocab::Delete(int ind)
{  int i;
   if(ind < 0 || ind >= n)
       return 1;
 WaitBusy();
 SetBusy();
   for(i=ind; i < n-1; i++)
      index[i] = index[i+1];
   n--;
 ReleaseBusy();
   return 0;
}
/*   ᫮ */
int Vocab::WriteIndex(char *_fnameto)
{   FILE *fpto;
    int i, maxPos,maxdPos, dpos, mindPos,maxWlen, maxAlen;
    int bytesPos, bytesWlen,bytesAlen;
    int compression;

/*  ᨬ 祭 樨  䠩   ᫮୮   ਡ */
   maxPos = 0;
   maxWlen = maxAlen = 0;
   for(i=0; i < n;i++)
   {  if(index[i].pos > maxPos)
               maxPos = index[i].pos;
      if(index[i].l > maxWlen)
               maxWlen = index[i].l;
      if(index[i].attr > maxAlen)
               maxAlen = index[i].attr;
   }
   bytesPos = 0;
   if(maxPos & 0xff) bytesPos = 1;
   if(maxPos & 0xff00) bytesPos = 2;
   if(maxPos & 0xff0000) bytesPos = 3;
   if(maxPos & 0xff000000) bytesPos = 4;
   bytesWlen = 0;
   if(maxWlen & 0xff) bytesWlen = 1;
   if(maxWlen & 0xff00) bytesWlen = 2;
   bytesAlen = 0;
   if(maxAlen & 0xff) bytesAlen = 1;
   if(maxAlen & 0xff00) bytesAlen = 2;

   mindPos = 0x7fffffff;
   maxdPos = -mindPos;
   for(i=1; i < n;i++)
   {  dpos = index[i].pos - index[i-1].pos;
      if(dpos > maxdPos)
              maxdPos = dpos;
      if(dpos < mindPos)
              mindPos = dpos;
   }
   if(mindPos > 0 && maxPos > maxdPos)
   {
      bytesPos = 0;
      if(maxdPos & 0xff) bytesPos = 1;
      if(maxdPos & 0xff00) bytesPos = 2;
      if(maxdPos & 0xff0000) bytesPos = 3;
      if(maxdPos & 0xff000000) bytesPos = 4;
      bytesPos |= 0x80;
   }

   compression = bytesPos | (bytesWlen << 8) | (bytesAlen <<16);


   fpto = fopen(_fnameto,"wb, blksize=32000");
   if(fpto == NULL)
   {    return 2;
   }
   printf("Write %s\n",_fnameto);
   WriteVocHeader(fpto ,0,compression,name,comment);
   if(compression)
   {   for(i = 0; i < n; i++)
       {
//was:       fwrite((void *)&index[i], sizeof(class VocabIndex) - sizeof(char *),1,fpto);
          if(bytesPos)
          {  dpos = index[i].pos;
             if(bytesPos & 0x80)
             {  if(i)
                {  dpos -= index[i-1].pos;
                    fwrite((void *)&dpos, (bytesPos&0x0f),1,fpto);
                } else {
                    fwrite((void *)&dpos, sizeof(int),1,fpto);
                }
             } else {
                fwrite((void *)&dpos,  bytesPos,1,fpto);
             }
          }
          if(bytesWlen)
          {   if((i == n-1) || !(bytesPos & 0x80) )
                      fwrite((void *)&index[i].l, bytesWlen,1,fpto);
          }
          if(bytesAlen)
              fwrite((void *)&index[i].attr,bytesAlen,1,fpto);
       }
   }
   fclose(fpto);

   return 0;
}

//⥭ 
int Vocab::ReadIndex(char *_fnamefrom)
{   FILE *fp;
    int nn, rc,flenIndex, pos, i;
    int bytesPos, bytesWlen, bytesAlen;
    int usecompresion;

    short int   d2;

    index = NULL;
    Error = 1;
//⠥ ᨢ ᮢ-㪠⥫ 
    fp = fopen(_fnamefrom,"rb, blksize=32000");
    if(fp == NULL)
        return 2;

    Error = 11; // ⨬ ࠬ   䠩
    rc = ReadVocHeader(fp,0, usecompresion, name, comment);
    if(rc)
    {   fclose(fp);
        return 3;
    }
     flenIndex = _filelength(fileno(fp));

     index = new VocabIndex[n];
     bytesPos  = usecompresion & 0xff;
     bytesWlen = (usecompresion>>8) & 0xff;
     bytesAlen = (usecompresion>>16) & 0xff;
     if(bytesPos+bytesWlen+bytesAlen)
     {
          nn = (flenIndex - ( sizeof(struct VocHeader) + strlen(name) + strlen(comment)+2 ) )
               / ( bytesPos+bytesWlen+bytesAlen );
         if(nn  < 1 )
         {   fclose(fp);
             return 4;
         }
     } else {
         memset((void *)index, 0, sizeof(VocabIndex) * n );
         Error = 0;
         fclose(fp);
         return 0;
     }

   if(usecompresion)
   {    Error = 3;  // 訡 ⥭

       for(i = 0; i < n; i++)
       {
//was:   rc = fread((void *)&index[i], sizeof(class VocabIndex) - sizeof(char *),1,fp);
          pos = 0;
          if(bytesPos)
          {    if(bytesPos & 0x80)
               {    if(i)
                    {    rc = fread((void *)&pos, (bytesPos&0x0f),1,fp);
                         pos += index[i-1].pos;
                    } else {
                         rc = fread((void *)&pos, sizeof(int),1,fp);
                    }
               } else {
                    rc = fread((void *)&pos, bytesPos,1,fp);
               }
               if(rc != 1)
                         return 5;
          }
          index[i].pos = pos;

          d2 = 0;
          if(bytesWlen)
          {   if(bytesPos & 0x80)
              {
                 if(i == n-1)
                 {  rc = fread((void *)&d2, bytesWlen,1,fp);
                    if(rc != 1)
                         return 5;
                 }
                 if(i > 0)
                 {  index[i-1].l = index[i].pos - index[i-1].pos;
                 }

              } else {
                  rc = fread((void *)&d2, bytesWlen,1,fp);
                  if(rc != 1)
                         return 5;
              }
          }
          index[i].l = d2;

          d2 = 0;
          if(bytesAlen)
          {   rc = fread((void *)&d2, bytesAlen,1,fp);
              if(rc != 1)
                         return 5;
          }
          index[i].attr = d2;
       }
   } else {
       for(i = 0; i < n; i++)
       {
          index[i].pos = 0;
          index[i].l = 0;
          index[i].attr = 0;
       }
   }

   fclose(fp);
   Error = 0;
   return 0;
}

// ᯨ᪠ ᫮
int Vocab::WriteWords(char *_fnameto)
{  FILE *fpto;
   int i,j,l1,l2, ll, minb, rep;
   char *pword, *pPrword, crep;
   int compression = 0;

   fpto = fopen(_fnameto,"wb, blksize=32000");
   if(fpto == NULL)
   {    return 2;
   }
/*  쭮 祭   ᯨ᪥ ᫮ */
   minb = 127;
   for(i = 0; i < n; i++)
   {
      pword = index[i].word;
      l2 = strlen(pword);
      for(j=0;j<l2;j++)
         if((int)pword[j] < minb)
                   minb = (int) pword[j];
   }
   --minb;
   printf("Write %s (%i)\n",_fnameto, minb);
   if(minb >= 9)
          compression = minb;
   WriteVocHeader(fpto ,1,compression,name,comment);

//was:  fwrite((void *)index[0].word, strlen(index[0].word)+1,1,fpto);
   if(compression)
   {
      fwrite((void *)index[0].word, strlen(index[0].word),1,fpto);
      for(i = 1; i < n; i++)
      {  pPrword = index[i-1].word;
         l1 = strlen(pPrword);
         pword = index[i].word;
         l2 = strlen(pword);
         ll = l2;
         if(l2 > l1)
                   ll = l1;
         if(ll > minb + 1)
               ll = minb + 1;
         rep = 0;
         for(j=0;j<ll;j++)
         {  if(pword[j] == pPrword[j])
                              rep++;
             else
                              break;
         }
         if(rep > 1)
         {  pword += rep;
            crep = (char) (rep-1);
         } else {
            crep = (char) 0;
         }
         fwrite((void *)&crep, 1,1,fpto);
         fwrite((void *)pword, strlen(pword),1,fpto);

      }
      crep = (char) 0;
      fwrite((void *)&crep, 1,1,fpto);
   } else {
      for(i = 0; i < n; i++)
      {  fwrite((void *)index[0].word, strlen(index[0].word)+1,1,fpto);
      }
   }

   fclose(fpto);

}

//⥭ ᯨ᪠ ᫮
int Vocab::ReadWords(char *_fnamefrom)
{  FILE *fp;
   int  flenWord, i, j, ll, l, rc,  iWorddata;
   int usecompresion,minb;
   char *pBuf, *pPrev, *pPrev0;
   char tmpName[VD_MAXPATH], tmpComment[VD_MAXPATH];

   Error = 1;
   fp = fopen(_fnamefrom,"rb");
   if(fp == NULL)
   {    return 3;
   }
// ⠥ 
   rc = ReadVocHeader(fp,1, usecompresion, tmpName, tmpComment);
     if(rc)
     {   fclose(fp);
         return 2;
     }
   if(!strlen(name))
       strcpy(name,tmpName);
   if(!strlen(comment))
       strcpy(comment,tmpComment);

   flenWord = _filelength(fileno(fp)) - ftell(fp);

//⥭ ⪠ 䠩
   pBuf = (char *) calloc(flenWord+1,1);
   rc = fread(pBuf,flenWord,1,fp);
   fclose(fp);

   if(usecompresion)
   {  minb = usecompresion;
//⠥  
      for(i=l=0;i<flenWord; i++)
      { if(pBuf[i] > minb)
                         l++;
        else
            l +=  2+(int)pBuf[i];
      }
      lenWorddata = l+1;
      Worddata = (char *) calloc(lenWorddata+2,1);

      pPrev = Worddata;
      for(i=l=0; i < flenWord; i++)
      { if(pBuf[i] > minb)
        {           Worddata[l++] = pBuf[i];
        } else {
            Worddata[l++] = 0;
            pPrev0 = &Worddata[l];
            ll =  (int)pBuf[i];
            if(ll)
            {  ll++;
               for(j = 0; j < ll; j++)
                     Worddata[l++] = pPrev[j];
            }
            pPrev = pPrev0;
        }
      }
      Worddata[l++] = 0;
      free(pBuf);

   } else {
     lenWorddata = l+1;
     Worddata =  pBuf;
     return 0;
   }

}



#define INCL_DOSPROCESS   /* DosSleep */
   #include <os2.h>

//   busy - ⥬-ᨬ ॠ
// 㯮 ᥬ ᯮᮡ -
//  㤥  -  ᤥ  -ଠ쭮
int Vocab::WaitBusy(void)
{  int raz=0;
   for(raz=0; raz< 10000; raz++)
   {  if(Busy == 0)
            return 0;
      DosSleep(1);
   }
   return 1;
}

// ⠭ busy
int Vocab::SetBusy(void)
{  Busy = 1;
   return 0;
}
// ⨥ busy
int Vocab::ReleaseBusy(void)
{
   Busy = 0;
   return 0;
}


#define POKA 0
#if POKA

vocab::vocab(char *language,char *dir, long int cache_size)
{
    char name[1024];
    strcpy(&name[0],dir);
    strcat(&name[0],language);
    strcpy(&dic_fname[0],&name[0]);
    binindex.open(strcat(&name[0],".bdx"));
    strcpy(&name[0],&dic_fname[0]);
    wordindex.open(strcat(&name[0],".wrd"));
    strcpy(&name[0],&dic_fname[0]);
    data.open(strcat(&name[0],".dat"));
    strcpy(&name[0],&dic_fname[0]);
    expander.read(strcat(&name[0],".exp"));
    binindex.readheader(header);
    allowed_chars=&header.letters[0];
    upper_chars=&header.uppercase[0];
    if(cache_size<50) cache_size=50;
    cache.resize(cache_size);
    wordcache.resize(cache_size);
    int sections=header.words_count/cache_size;
    if((header.words_count-sections*cache_size)>0) sections++;
    cachesize=cache_size;
    shortlist.resize(sections);
    strcpy(&name[0],&dic_fname[0]);
    strcat(&name[0],".");
    char buf[10];

    _itoa(cache_size,buf,16);
    FILE* shlist=fopen(strcat(&name[0],&buf[0]),"rb");
    unsigned long int ID_DIC;
    if(shlist!=NULL && (fread(&ID_DIC,sizeof(ID_DIC),1,shlist),ID_DIC==header.ID))
    {
         /* ⥭ 쪮   䠩 */
         struct stat st;
         fstat(fileno(shlist), &st);
         char* v= (char*) malloc(st.st_size);
         fread(v,sizeof(char),st.st_size,shlist);
         char* pos=v;
         for(int i=0;i<sections;i++)
         {
              shortlist[i]=pos;
              pos+=shortlist[i].length()+1;
         }
         fclose(shlist);
         free(v);
    } else
    {
         fclose(shlist);
         shlist=fopen(&name[0],"wb");
         fwrite(&header.ID,sizeof(header.ID),1,shlist);
         char c='\0';
         for(int i=0;i<sections;i++)
         {
              wordindex.get(shortlist[i],binindex.get(i*cache_size));
              strtoupper(shortlist[i]);
              check(shortlist[i]);
              fwrite(shortlist[i].getsamestr(),shortlist[i].length(),1,shlist);
              fwrite(&c,sizeof(c),1,shlist);
         }
         fclose(shlist);
    }
    fillcache(0);
    _current=0;
    cache_first=0;
    getword(last,header.words_count-1);
    check(strtoupper(last));

};

void vocab::fillcache(long int pos)
{
     binindex.fill(cache,pos,cachesize);
     wordindex.fill(wordcache,cache);
     cache_first=pos;
     return;
};


String& vocab::check(String& str)
{
    int i,j;
    for(i=j=0;i<str.length()+1;i++)
        if(in_letters(str[i])!=0){str[j]=str[i];j++;};
    str.length()=j;
    return str;
};


String& vocab::strtoupper(String& str)
{
    char* s=str.getsamestr();
    while(*s){s[0]=toupper(s[0]);s++;};
    return str;
};


int  vocab::first_letter(String& s)
{
    String s1=s;
    strtoupper(s1);
    expand(s1);
    int p=0;
    char* pos=s1.getsamestr();
    while(pos[p]!=0)
    {
        if(in_letters(pos[p])==1)
            return p;
        p++;
    };
    return 65535;
};


void vocab::getlist(TWordList& list, long int pos, long int count)
{
     TWordDataList datalist;
     binindex.fill(datalist,pos,count);
     wordindex.fill(list,datalist);
     return;
};



long int vocab::search(String& str1)
{
     String str=str1;
     check(expand(strtoupper(str)));
     if(str<shortlist[0]) {_current=0;return 0;};
     if(str>last) {_current=header.words_count-1;return _current;};
     check(strtoupper(wordcache[0]));
     check(strtoupper(wordcache[wordcache.count()-1]));
     long int n,n1,n2;
     if(str>wordcache[wordcache.count()-1] || str<wordcache[0])
     {
           n1=0;n2=shortlist.count()-1;
           n=0;
           while((n2-n1)>5)
           {
                n=n1+(n2-n1)/2;
                if(str<shortlist[n]) n2=n;
                  else n1=n;
           }
           for(n=n2;n>=n1;n--)
                if(str>=shortlist[n])
                    break;

           fillcache(n*cachesize);
     }

     n1=0;n2=cache.count-1;

     while((n2-n1)>5)
     {
          String s;
          n=n1+(n2-n1)/2;
          s=wordcache[n];
          check(strtoupper(s));
          if(str<s) n2=n;
            else n1=n;
     }
     int best, bestpos,c;
     best=numcmp(str,check(strtoupper(wordcache[n1])),0,0);
     bestpos=n1;
     for(n=n1+1;n<=n2;n++)
         if((c=numcmp(str,check(strtoupper(wordcache[n])),0,0))>best)
         {
           best=c;bestpos=n;
         }
     _current=cache_first+bestpos;
     return cache_first+bestpos;

};

long int vocab::score(String& str)
{
     String s=str;
     check(expand(strtoupper(s)));
     String res;
     getword(res,_current);
     check(strtoupper(res));
     return numcmp(s,res);
}

#endif //POKA





