/* slovarCGI.cpp */
//#include "dicshell.h"
#define DEBUG 0

#include <stdio.h>
#include <stdlib.h>
#include <locale.h>
#include "slovar.h"

/*+---------------------------------+*/
/*| Internal function prototypes.   |*/
/*+---------------------------------+*/

void puthelp(void);
int  mainCMD(int n, char *par[]);
int  mainCGI(int n, char *par[]);

int GetDictInfo(char *sDictname,char *sBuff, int nBuffLen);
int QueryDictWord(char *sDictname,char *word, int &ind, int &isExactly, char *sFindword, char *sBuff, int nBuffLen);
int AddDictWord(char *sDictname, char *word, char *article);
int ImportDict(char *sDictname,char *fname, char *format, char *VocName, char *VocComment,
               char * pDictLocale, char * pDictLocaleArticle, char *Separator);


int GetClientQuery(char *word, int &nWindowX, int &nWindowY, int &IsExtendedMode,
                   char *slovarFname, int &decodeMode);
int AnswerToClient(char *srcWord,char *pNearWords[],int nNear,int idCurrent,char *sBuff);
int QueryCGIDictWord(unsigned char *word, int mode, int nWindowX, int nWindowY,int IsExtendedMode, char *slovarFname);
int ErrorCGIinform(int code, char *message, char *message1);

int StrFromKoi(unsigned  char *str);
int StrFromKoi(unsigned  char *str, int decodeMode);

int StrToKoi(unsigned char *str);
int StrToKoi(unsigned char *str, int decodeMode);
// getenv  ⫠
char *sl_getenv(char *var);

/*+--------------------------------------------------------+*/
/*| Static global variables and local constants.           |*/
/*+--------------------------------------------------------+*/

const char *HeadInfo[]=
{ "Slovar2 v." VD_VERSION "." VD_SUBVERSION" CommandLine & CGI interface vers. 0.31" ,
  "(c)Nike Korolev, Evgeny Kotsuba "  __DATE__ ,
  NULL
};

class Vocab *dics, *dics1;
char *plocale = NULL;
char *plocaleArticle= NULL;

char *ProgName;
#define BUFFSIZE 4096
char sWord[BUFFSIZE];
char sBuff[BUFFSIZE];
char sOutBuff[BUFFSIZE];
char slovarFname[256];

FILE *fpLOG; // ⫠筠 ଠ

#define CGIVERS  "0.3"

/*  p p -   p   CGI */
int main(int n, char *par[])
{  int rc;

   if(sl_getenv("SCRIPT_FILENAME"))
            rc = mainCGI( n,par);
   else
            rc = mainCMD( n,par);
   return rc;
}


int mainCGI(int n, char *par[])
{  int rc, ind, isExactly, mode;
   FILE *fp;
   char *plang, *pstr;
   int nWindowX, nWindowY,IsExtendedMode, decodeMode;
//  fpLOG=fopen( "slovar2.log","a");


//⠭ 
   plocale = setlocale(LC_ALL,"RU_RU.IBM-866");

//   fprintf(fp,"SetlocaleRU_RU.IBM-866 rc=%s\n",plocale);
//᫨  ⠪ - ६  㦥 LANG
   plang =sl_getenv("LANG");
//   fprintf(fp,"LANG= %s\n", plang );
//   pstr =getenv("PATH");
//   fprintf(fp,"PATH=%s\n", pstr );

//   system("set>set.tst");

   if(plocale == NULL)
   {
      plocale = setlocale(LC_ALL,plang );
//      fprintf(fp,"Setlocale %s rc=%s\n",plang,plocale);
   }
   if(plocale == NULL)
   {  plocale = setlocale(LC_ALL,"RU_RU" );
//      fprintf(fp,"Setlocale RU_RU rc=%s\n", plocale);
   }
//   fclose(fp);


 mode = GetClientQuery(sWord,nWindowX,nWindowY,IsExtendedMode,slovarFname, decodeMode);

 if( mode >=0)
    QueryCGIDictWord((unsigned char *)sWord, mode,nWindowX,nWindowY,IsExtendedMode,slovarFname );


    fflush(stdout);
    fpLOG=fopen( "slovar2.log","a");
    fprintf(fpLOG,"Ok\n");
    fclose(fpLOG);
    return 0;
}
/*    */
/* p頥 0/1  ᪮ p/javascript "word"/"wordj" */
/* decodeMode - 0/1/2 -  ᯮ짮 pp, koi8, unicode */
int GetClientQuery(char *word, int &nWindowX, int &nWindowY, int &IsExtendedMode, char *slovarFname, int &decodeMode)
{   int i,j,jj,l, n, is, v, rc = 0, unicodeUse=0;
    char *pArgNames[20];
    char *pArgValues[20];
    char str[512], stmp[64], *ps, *ps1;

    decodeMode = 0;
#if DEBUG
//  ⫠  
//  strcpy(sBuff,"wordj=abracadabra&extmode=1&wordlist=%C1%C2%D2%C1%CB%C1%C4%C1%C2%D2%C1&wnX=610&wnY=403");
  strcpy(sBuff,"wordj=%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1&extmode=1&wordlist=%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1%C1&wnX=610&wnY=474&d1=zdict");

//  strcpy(sBuff,"wordj=%C1%C2%CF%CE%C5%CD%C5%CE%D4&extmode=1&wordlist=%C1%C2%CF%CE%C5%CD%C5%CE%D4&wnX=834&wnY=349");
#else
    gets(sBuff);
#endif


    fpLOG=fopen( "slovar2.log","a");
   {
    struct tm *newtime;
    time_t ltime;
    /* Get the time in seconds */
    time(&ltime);
    /* Convert it to the structure tm */
    newtime = localtime(&ltime);
    fprintf(fpLOG,"%s",asctime(newtime));
   }
    fprintf(fpLOG,"%s\n",sBuff);
   fclose(fpLOG);


////  fprintf(fpLOG,"Read %s\n", sBuff);
////  fflush(fpLOG);

// sBuff ᮤন - 
// word=qqqq&wordlist=ccc&button=%F3%CC%CF%D7%CF%3A

// ।塞,   ᪨  - ᫨ ,      koi8-r
    ps = sl_getenv("HTTP_ACCEPT_LANGUAGE");

    if(ps)
    {     if(!stricmp(ps,"ru") )
                     decodeMode = 1;
          else //   - ⨯ =ru,en-us;q=0.5
          {  strcpy(str,ps);
           /* ⠥   */
             l = strlen(str);
             ps1 = &str[0];
             for(i=0;i<l;i++)
             {   if(str[i] ==',')
                 {  str[i] = ' ';
                    sscanf(ps1,"%s",stmp);
                    if(!stricmp(stmp,"ru") )
                    {  decodeMode = 1;
                       break;
                    }
                    ps1 = &str[i+1];
                 } else
                    if(str[i] ==';')
                          str[i] = ' ';
             }
             if(!decodeMode)
             {    str[i] = ' ';
                  sscanf(ps1,"%s",stmp);
                  if(!stricmp(stmp,"ru") )
                  {  decodeMode = 1;
                  }
             }
          }
    }

// ।塞,   প utf-8
    ps = sl_getenv("HTTP_ACCEPT_CHARSET");
    if(ps)
    {
       if(strstr(ps,"utf-8") )
                     unicodeUse = 1;
    }

    l = strlen(sBuff);
    pArgNames[0] = &sBuff[0];
    n = 1;
    for(i=0;i<l;i++)
    {  if(sBuff[i] ==  '=')
       { sBuff[i] = 0;
         pArgValues[n-1]= &sBuff[i+1];
       } else
             if(sBuff[i] ==  '&')
       { sBuff[i] = 0;
         pArgNames[n++]= &sBuff[i+1];
       }
    }

//    printf("<BR>\n");
//    printf("Name     Value<BR>\n");
//    for(i=0;i<n;i++)
//    { printf("%s    %s\n",pArgNames[i],pArgValues[i]);
//      printf("<BR>\n");
//    }
//    printf("<BR>\n");

/* 㡨ࠥ  %F3 -  ࠧ */
    for(i=0;i<n;i++)
    {  l = strlen(pArgNames[i]);
       ps = pArgNames[i];
       for(jj=j=0;j<l;j++)
       {  if(ps[j] != '%') str[jj++] = ps[j];
          else
          {  stmp[0] = ps[j+1]; stmp[1] = ps[j+2]; stmp[2] = 0;
             v=strtol(stmp,&ps1,16);
             str[jj++] = (char) v;
             j+= 2;
          }
       }
       str[jj] = 0;
       strcpy(ps, str);

       l = strlen(pArgValues[i]);
       ps = pArgValues[i];
       for(jj=j=0;j<l;j++)
       {
          if(ps[j] == '+') str[jj++] = ' ';
          else
             if(ps[j] == '%')
          {  stmp[0] = ps[j+1]; stmp[1] = ps[j+2]; stmp[2] = 0;
             v=strtol(stmp,&ps1,16);
             str[jj++] = (char) v;
             j+= 2;
          }
           else
            str[jj++] = ps[j];
       }
       str[jj] = 0;
       strcpy(ps, str);
    }
    if(!strcmpi(pArgNames[0],"wordj") )
                                   rc= 1;
    else
         if(!strcmpi(pArgNames[0],"worduj") )
         {
             if(unicodeUse == 0)
             {
                 ErrorCGIinform(0, "Browser must have UTF-8 support ", sl_getenv("HTTP_USER_AGENT") );
                 rc = -1;

             } else {
                rc= 2; // use UNICODE
                decodeMode = 2;
             }
         }

    strcpy(word,pArgValues[0]);
    StrFromKoi((unsigned char *)word, decodeMode);

    nWindowX=0;
    nWindowY=0;
    IsExtendedMode =0;
    if(slovarFname) *slovarFname = 0;
    for(i=1;i<n;i++)
    {  if(!strcmpi(pArgNames[i],"extmode") )
                          IsExtendedMode = atoi(pArgValues[i]);
       if(!strcmpi(pArgNames[i],"wnX") )
                          nWindowX = atoi(pArgValues[i]);
       if(!strcmpi(pArgNames[i],"wnY") )
                          nWindowY = atoi(pArgValues[i]);
       if(!strcmpi(pArgNames[i],"d1") )
                         strcpy(slovarFname,pArgValues[i]);
    }

   fpLOG=fopen( "slovar2.log","a");
   fprintf(fpLOG,"Query=%s, %i,%i in %s, decodeMode %i\n",word,rc,IsExtendedMode, slovarFname,decodeMode);

   fprintf(fpLOG,"REMOTE_ADDR=%s ",sl_getenv("REMOTE_ADDR") );
   fprintf(fpLOG,"REMOTE_HOST =%s\n",sl_getenv("REMOTE_HOST ") );
   fprintf(fpLOG,"H_USER_AGENT=%s, w=%i,h=%i\n",sl_getenv("HTTP_USER_AGENT"),nWindowX,nWindowY );
   fprintf(fpLOG,"H_ACCEPT_CHARSET =%s\n",sl_getenv("HTTP_ACCEPT_CHARSET") );
   fprintf(fpLOG,"H_ACCEPT_LANGUAGE =%s\n",sl_getenv("HTTP_ACCEPT_LANGUAGE") );

   fclose(fpLOG);

//      printf("Name     Value\n");
//      printf("<HR>\n");
//    for(i=0;i<n;i++)
//    {
//      printf("%s    %s\n",pArgNames[i],pArgValues[i]);
//      printf("<BR>\n");
//    }
//    printf("<BR>\n");

//    fprintf(fpLOG,"Decode to pArgNames\t pArgValues:\n");
//    fprintf(fpLOG,"%s %s (%s)\n",pArgNames[0],pArgValues[0],word );
//    fprintf(fpLOG,"%s %s\n",pArgNames[1],pArgValues[1]);
//    fprintf(fpLOG,"%s %s\n",pArgNames[2],pArgValues[2]);
//    fflush(fpLOG);

      return rc;
}

/* ⢥ - ᪨ html */
int AnswerToClient(char *srcWord,char *pNearWords[],int nNear,int idCurrent,char *sBuff)
{   int i;
    printf("Content-type: text/html\n");
    printf("\n");
    printf ("<!DOCTYPE HTML PUBLIC \"-//W3O//DTD W3 HTML 3.2//EN\">\n");
    printf("<HTML>\n<HEAD>\n");
    printf("<meta name=\"Author\" content=\"evgen\">\n");
    printf("<meta name=\"GENERATOR\" content=\"Slovar2/" CGIVERS "[ru] (OS/2)\">\n");
    printf("<TITLE>Web Slovar2 vers." CGIVERS "</TITLE>\n");
    printf("</HEAD>\n");

//   <meta name="Author" content="Evgeny">
//   <meta name="GENERATOR" content="Mozilla/4.61 [ru] (OS/2; I) [Netscape]">

    printf("<BODY>\n");
    printf("<H3>Web Slovar2 test</H3>\n");
    printf("<table BORDER CELLPADDING=4 >");
    printf("<tr>");
    printf("<td COLSPAN=\"2\">");
     strcpy(sOutBuff,":");
     StrToKoi((unsigned char *) sOutBuff);
     printf("%s\n",sOutBuff);
     printf("<br>");

     printf("<form method=post action=\"/cgi-bin/slovar2.exe\">");


     strcpy(sOutBuff,srcWord);
     StrToKoi((unsigned char *)sOutBuff);
     printf("<input type=text size=40 name=\"word\" value=\"%s\">\n",sOutBuff);

      printf("</td></tr>");
      printf("<tr><td>");

//   printf("<select name=\"wordlist\" multiple size=%i>\n",nNear);
     printf("<select name=\"wordlist\" size=%i>\n",nNear);

    for(i=0;i<nNear;i++)
    {  strcpy(sOutBuff,pNearWords[i]);
       StrToKoi((unsigned char *)sOutBuff);
       if(i == idCurrent)
               printf("<option  selected>%s\n",sOutBuff);
       else
               printf("<option>%s\n",sOutBuff);
    }
     printf("</select>");

    printf("</form></td>");

    printf("<td>");
    printf("<form>");
    printf("<textarea Name=\"article\" rows=20 cols=50>");
 //WRAP=off rows=20 cols=40>blalalal</textarea>

     StrToKoi((unsigned char *)sBuff);
     printf("%s\n",sBuff);
    printf("</textarea>");
    printf("</form>");

    printf("</td>");
    printf("</tr>");
    printf("</table>");

    printf("<HR>\n");
    printf("</BODY>\n");
    printf("</HTML>\n");
    printf("\n");

}


/**************************************************************/
/* ᪨ ⢥ -  html+ javascript                     */
/* srcWord - ᫮, ஥ ᪠                            */
/* pNearWords[] - ᯨ᮪ ᫮  ᭮ ᫮ ᪠       */
/* nNear        - ᫮ ᫮  ᯨ᪥                         */
/* idCurrent    -  ⥪饣(࠭) ᫮  ᯨ᪠  */
/* sBuff        - ᫮ୠ                             */
/* nWindowX,..Y - ࠧ                          */
/* IsExtendedMode ࠡ  ७ ०(ன)      */
/* slovarFname  -  ᯮ㥬 ᫮                   */
/* pLocaleWord  -   ᫮  ᯨ᪠ ᫮,  ன  */
/*                  뤠  (㪮祭 ) */
/*                ru  ru_ru, de  de_de                  */
/* decodeMode  - 0/1/2 -  ஢/cp866-Koi8r/UTF-8  */
/**************************************************************/
int AnswerJSToClient(char *srcWord,char *pNearWords[],int nNear,int idCurrent,
                     char *sBuff, int nWindowX, int nWindowY, int IsExtendedMode, char *slovarFname,
                     char *pLocaleWord, int decodeMode  )
{   int i,l;
    int Nwordlist = 10;
    int Nrows_article =10;
    int Ncols_article =40;
    char sWordLang[64];

    if(pLocaleWord && pLocaleWord[0])
    {   char stmp[64];
           strcpy(stmp,pLocaleWord);
    /* ru_ru -> ru */
           stmp[2]=0;
           sprintf(sWordLang,"lang=\"%s\"",stmp);
    }
    else
              sWordLang[0] = 0;

//蠥,  ࠧ  ᨬ    
    if(nWindowX > 0)
           Ncols_article = 30 + (nWindowX-110)/20;
    if(Ncols_article > 100) Ncols_article = 100;

    if(nWindowY > 0)
    { Nwordlist = 5 + (nWindowY-120)/20;
      if (Nwordlist > 100) Nwordlist = 100;
      Nrows_article  = 5 + (nWindowY-130)/20;
      if (Nrows_article > 100) Nrows_article = 100;
    }

    if(Nwordlist > nNear) Nwordlist = nNear;
    l = strlen(sBuff);
    if(Nwordlist < (Nrows_article+2) && (l/(Ncols_article) < Nwordlist))
                                                   Nrows_article = Nwordlist-2;


    printf("Content-type:text/html\n\n");

    printf ("<!DOCTYPE HTML PUBLIC \"-//W3O//DTD W3 HTML 4.0//EN\">\n");
    printf("<HTML>\n<HEAD>\n");

//    printf("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" \n\n");

    printf("<meta name=\"Author\" content=\"evgen\">\n");
    printf("<meta name=\"GENERATOR\" content=\"Slovar2/" CGIVERS "[ru] (OS/2)\">\n");

     strcpy(sOutBuff,srcWord);
     StrToKoi((unsigned char *)sOutBuff, decodeMode);
    printf("<TITLE>%s WebSlovar2 v." CGIVERS "</TITLE>\n",sOutBuff);
    printf("</HEAD>\n");

    printf("<BODY onLoad=\"setFocus()\">\n");
//    printf("<BODY\n");

    printf("<B>Web Slovar2 JavaScript test</B>\n");
    printf("<table BORDER CELLPADDING=4 >");
    printf("<tr>");
    printf("<td COLSPAN=\"2\">");
     strcpy(sOutBuff,":");
     StrToKoi((unsigned char *) sOutBuff, decodeMode);
     printf("%s\n",sOutBuff);
     printf("<br>");

     printf("<form name=\"form1\" method=post action=\"/cgi-bin/slovar2.exe\">");


     strcpy(sOutBuff,srcWord);
     StrToKoi((unsigned char *)sOutBuff, decodeMode);
     printf("<input type=text size=40 name=\"wordj\" %s value=\"%s\">\n",sWordLang,sOutBuff);
     if(IsExtendedMode)
          printf("<input type=checkbox  name=\"extmode\" value=\"1\" checked> Ext.\n");
     else
          printf("<input type=checkbox  name=\"extmode\" value=\"1\"> Ext.\n");

      printf("</td></tr>");
      printf("<tr><td>");
//   printf("<select name=\"wordlist\" multiple size=%i %s onChange=\"OnWordListChange()\">\n",Nwordlist, sWordLang);
     printf("<select name=\"wordlist\" size=%i %s onChange=\"OnWordListChange()\">\n",Nwordlist, sWordLang);

    for(i=0;i<nNear;i++)
    {  strcpy(sOutBuff,pNearWords[i]);
        StrToKoi((unsigned char *)sOutBuff, decodeMode);
       if(i == idCurrent)
               printf("<option  selected>%s\n",sOutBuff);
       else
               printf("<option>%s\n",sOutBuff);
    }
     printf("</select>");
 //⮡   ࠧ  㧥

// 㤮⢠ ࠡ  ࠧ  ࠧ  㥬  䨪  ᪮쪮 ப
    printf("<SCRIPT LANGUAGE=\"JavaScript\">\n");
    printf("<!--\n");
    printf("var W1, W2;");
    printf("W1=window.innerWidth;");
    printf("W2=window.innerHeight;");
// ⠪  . ⠪  ᪠  " १ printf"
//  document.write("<BR><input type=\"hidden\" name=\"wnX\" value=\""+W1+"\">");
    printf("document.write(\"<BR><input type=\\\"hidden\\\" name=\\\"wnX\\\" value=\\\"\"+W1+\"\\\">\");");
//  document.write("<BR><input type=\"hidden\" name=\"wnY\" value=\""+W2+"\">");
    printf("document.write(\"<BR><input type=\\\"hidden\\\" name=\\\"wnY\\\" value=\\\"\"+W2+\"\\\">\");");
    printf("// -->\n");
    printf("</SCRIPT>\n");
    if(slovarFname && strlen(slovarFname) > 1)
          printf("<input type=\"hidden\" name=\"d1\" value=\"%s\">\n",slovarFname);

    printf("</form></td>");

    printf("<td><form name=\"form2\">");
    printf("<textarea Name=\"article\" WRAP=on rows=%i cols=%i>",Nrows_article,Ncols_article);
 //WRAP=off rows=20 cols=40>blalalal</textarea>

     StrToKoi((unsigned char *)sBuff, decodeMode);
     printf("%s\n",sBuff);
    printf("</textarea>");
    printf("</form>");

    printf("</td>");
    printf("</tr>");
    printf("</table>");

    printf("<HR>\n");
    printf("</BODY>\n");
    printf("<SCRIPT LANGUAGE=\"JavaScript\">\n");
    printf("<!--\n");
    printf("function setFocus() \n");
    printf("{  document.form1.wordlist.focus();\n");
    printf("}\n");
    printf("function OnWordListChange(e)\n");
    printf("{  var wordtmp = document.form1.wordlist.options[document.form1.wordlist.selectedIndex].text;\n");
    printf("document.form1.wordj.value= wordtmp;\n");

//    printf("document.form1.wnX.value= \"1\";\n");
//    printf("document.form1.wnY.value= \"2\";\n");
    printf("document.form1.submit();\n");
    printf("}");

    printf("// -->");
    printf("</SCRIPT>\n");

    printf("</HTML>\n");
    printf("\n");

}

int ErrorCGIinform(int code, char *message, char *message1)
{
    printf("Content-type: text/html\n\n");
    printf ("<!DOCTYPE HTML PUBLIC \"-//W3O//DTD W3 HTML 3.2//EN\">\n");
    printf("<HTML>\n<HEAD>\n");

    printf("<meta name=\"Author\" content=\"evgen\">\n");
    printf("<meta name=\"GENERATOR\" content=\"Slovar2/" CGIVERS "[ru] (OS/2)\">\n");
    printf("<TITLE>Web Slovar2 vers." CGIVERS "</TITLE>\n");
    printf("</HEAD>\n");
    printf("<BODY>\n");
    printf("<B>Error at Slovar2 executing: <BR>");
    if(message)
           printf("%s",message);
    printf(" (%i) <BR>", code);
    if(message1)
           printf("%s</B>",message1);

    printf("<HR>\n");
    printf("</BODY>\n");
    printf("</HTML>\n");
    printf("\n");
}

char *ErrorMessage(int errcode)
{   static char str[256];
    char *perr;
    switch(errcode)
    {  case 1:
           strcpy(str,"Can't open file");
         break;
       case 2:
           strcpy(str,"Error writing file");
       case 3:
           strcpy(str,"Error reading file");
         break;
       case 4:
           strcpy(str,"Invalid option");
         break;
       case 10:
           strcpy(str,"can't set locale");
         break;
       case 11:
           strcpy(str,"Ivalid file header");
         break;
       default:
           strcpy(str,"Error");
    }
    perr =str;
    return perr;
}

int QueryCGIDictWord(unsigned char *word, int mode, int nWindowX, int nWindowY,int IsExtendedMode, char *slovarFname)
{  int i,j,l,isengl,nNear=0, idCurrent;
   int rc=0;
   int isExactly, ind;
   char *pNearWords[20];

   if(slovarFname && strlen(slovarFname) >1 )
   {
      dics = new Vocab(slovarFname);
   } else {

      l = strlen((char *) word);

      isengl = 0;
     for(i=0;i<l;i++)
     {
       if(word[i] >= 65 && word[i] <= 90) isengl++;
       else
           if(word[i] >= 97 && word[i] <= 122) isengl++;
     }
     if(isengl <  (l/2)) isengl = 0;


     if(isengl)
     {   dics = new Vocab("engrus");
     } else  {
        dics = new Vocab("ruseng");
     }
  }

   if(dics->Error)
   {  rc = 1;
      ErrorCGIinform(dics->Error, ErrorMessage(dics->Error),dics->fname );

   } else {
       ind = dics->Search((char *) word);

       isExactly = 1;
       if(dics->Error) isExactly = 0;
       nNear = 20;
       if(dics->n < nNear)
                   nNear = dics->n;
       j = ind - 9;
       if(j < 0) j = 0;
       if(j + nNear > dics->n)
              j = dics->n - nNear;
       for(i=0; i < nNear;i++)
       {   pNearWords[i] = dics->index[j+i].word;
           if(j+i == ind)
               idCurrent = i;
       }

//       strcpy(sFindword,dics->index[ind].word);

       rc = dics->GetArticle(ind, sBuff,  BUFFSIZE);

       if(mode)
          AnswerJSToClient((char *)word,pNearWords,nNear,idCurrent, sBuff, nWindowX, nWindowY,
                           IsExtendedMode, slovarFname,dics->Locale, mode);
       else
          AnswerToClient((char *)word,pNearWords,nNear,idCurrent, sBuff);

   }

   delete dics;
   return rc;

}
int Query_CGIDictWord(char *sDictname,char *word, int &ind, int &isExactly,
                  char *sFindword, char *sBuff, int nBuffLen)
{ int rc=0;
   dics = new Vocab(sDictname);
   if(dics->Error)
   {  rc = 1;
   } else {
       ind = dics->Search(word);
       isExactly = 1;
       if(dics->Error) isExactly = 0;
       strcpy(sFindword,dics->index[ind].word);

       rc = dics->GetArticle(ind, sBuff,  nBuffLen);
   }
   delete dics;
   return rc;
}
/********************/
/*  ப */
/********************/
int mainCMD(int n, char *par[])
{  int rc, ind, isExactly;
   char *pDictLocale = NULL;
   char *pDictLocaleArticle = NULL;
   char *pSeparator = NULL;

   plocale = setlocale(LC_ALL,"RU_RU.IBM-866");

   ProgName = par[0];
   if(n < 3)  puthelp();
   if(!stricmp(par[1],"-help") || !stricmp(par[1],"-?") ) puthelp();
   if(!stricmp(par[1],"/help") || !stricmp(par[1],"/?") ) puthelp();

   if(!stricmp(par[2],"I") )       // I(nfo)
   {   if(n != 3) puthelp();
       rc = GetDictInfo(par[1],sBuff,BUFFSIZE);
       if(!rc)
            printf("%s",sBuff);
       return 0;
   } else
         if(!stricmp(par[2],"Q") ) {  // Q(uery)

       if(n != 4) puthelp();

       rc =
         QueryDictWord(par[1], par[3], ind, isExactly, sWord, sBuff,BUFFSIZE );
       if(!rc)
       {  printf("Find ");
          if(isExactly)
             printf("exactly ");
          else
             printf("nearest ");
          printf("%s %i\n%s",  sWord,ind,sBuff);

          return 0;
       }
   } else
         if(!stricmp(par[2],"A") ) { //A(dd)
// ᫮  ᫮
       if(n != 5) puthelp();
       rc = AddDictWord(par[1], par[3], par[4]);
       if(!rc)
       {   printf("Added\n");
          return 0;
       } else {
           printf("Already in dict\n");
       }
   } else
         if(!stricmp(par[2],"M") ) { //M(ake)  import
      if(n < 7 || n > 11) puthelp();
      if(!strcmp(par[4],"2") )
      {   rc = 1;
          if(stricmp(par[5],"-s") || n < 9)
                            puthelp();
          pSeparator = par[6];

          if( n >= 10)
               pDictLocale = par[9];
          if( n == 11)
               pDictLocaleArticle = par[10];
          rc = ImportDict(par[1],par[3],par[4],par[7],par[8], pDictLocale,pDictLocaleArticle,pSeparator);

      } else {

         if( n == 8)
               pDictLocale = par[7];
          rc = ImportDict(par[1],par[3],par[4],par[5],par[6], pDictLocaleArticle ,pDictLocale,NULL);
      }
      if(!rc)
         printf("\nOk");
   }

   return 1;
}

void puthelp(void)
{
  printf("\n%s\n%s\n\n",HeadInfo[0],HeadInfo[1]);
  printf("USAGE: %s  <VocName> <Cmd> <Arg>\n",ProgName);
  printf("VocName = vocabulary name\n");
  printf("Cmd = Q|I|A|M - Query | Info | Add | Make(import from external format) \n");
  printf("Q(uery) word\t \"VocName Q  QueryWord\"\n");
  printf("I(nfo)\t\t \"YourVocName I\"\n");
  printf("A(dd) word wordArticle\t \"VocName A  ABC \"1.Alphabet\\n2.Alphabet book\"\n");
  printf("M(ake) VocName FileFrom Frmt [-s sep] vName vComment [LocaleW] [LocaleArt]\n");
  printf("\tFrmt = 0/1/2 - Korolev's text format/Slovo/<word><sepr><art>\\n\n");
  printf("\tsep  = separator ( \"=\", \"  \", \"\", etc.)\n");
  printf("\tLocaleW   = Locale for searching and sorting in list of words\n");
  printf("\tLocaleArt = Locale for article text\n");
  printf("\tYour current Locale=%s\n",sl_getenv("LANG"));

  printf("Example: M ruseng ruseng.txt 0 \"Russ.-engl. voc.\" \"Compiled by Nike Korolev\" \n");
  exit(1);
}

int ImportDict(char *sDictname,char *fname, char *format, char *VocName, char *VocComment,
               char * pDictLocale, char * pDictLocaleArticle, char *Separator)
{ int rc=0;
  Vocab dics;
  char *pstr;
//஢塞 稥   ᫮୮ 
  if(pDictLocaleArticle)
  {   plocaleArticle = SlovarSetLocale(pDictLocaleArticle);
      if(!plocale)
      {  printf("\aWarning: Can't set Locale for Articles %s\n", pDictLocaleArticle);
         plocaleArticle = sl_getenv("LANG");
         printf("Locale for articles set to%s\n", plocaleArticle);
      }
  } else {
      plocaleArticle = sl_getenv("LANG");
      printf("Locale for articles set to %s\n", plocaleArticle);
  }
  strcpy(dics.LocaleArticle,plocaleArticle);

// ⠭   ᯨ᪠ ᫮
  if(pDictLocale)
  {
      plocale = SlovarSetLocale(pDictLocale);
      if(!plocale)
      {  printf("\aError: Can't set Locale %s\n", pDictLocale);
         return 2;
      }

  } else {
// ६   LANG=
      plocale = sl_getenv("LANG");
      plocale = setlocale(LC_ALL,plocale);
      if(plocale == NULL)
      {  printf("Warning: Can't set Locale %s\n", sl_getenv("LANG"));
      }
      printf("Locale for words set to %s\n", plocale);
  }
  strcpy(dics.Locale,plocale);

  if(!strcmp(format,"0") )
        rc = dics.Import(fname,sDictname,VocName,VocComment);
  else if(!strcmp(format,"1") )
        rc = dics.Import0(fname,sDictname,VocName,VocComment);
  else if(!strcmp(format,"2") )
        rc = dics.Import1(fname,sDictname,VocName,VocComment,Separator);

  return rc;
}

int GetDictInfo(char *sDictname,char *sBuff, int nBuffLen)
{ int rc=0;
   dics = new Vocab(sDictname);
   if(dics->Error)
   {  rc = 1;
   } else {
     sprintf(sBuff, "%s\n%s\n%i articles\nCreated %sLast change%s",
           dics->name, dics->comment,dics->n, ctime(&dics->CreationTime), ctime(&dics->LastchangeTime));
   }
   delete dics;

   return rc;
}

int QueryDictWord(char *sDictname,char *word, int &ind, int &isExactly,
                  char *sFindword, char *sBuff, int nBuffLen)
{ int rc=0;
   dics = new Vocab(sDictname);
   if(dics->Error)
   {  rc = 1;
   } else {
       ind = dics->Search(word);
       isExactly = 1;
       if(dics->Error) isExactly = 0;
       strcpy(sFindword,dics->index[ind].word);

       rc = dics->GetArticle(ind, sBuff,  nBuffLen);
   }
   delete dics;
   return rc;
}

// ᫮  ᫮
int AddDictWord(char *sDictname, char *word, char *article)
{  int rc=0;
   dics = new Vocab(sDictname);
   if(dics->Error)
   {  rc = 1;
   } else {
      rc = dics->Add(word, article);
   }

   delete dics;
   return rc;
}

void mainold()
{  int rc,ind;
   char *s1, *s2, *s3, *s4, *s5, *s6;
   char str[512];

   {
//      plocale = setlocale(LC_ALL,NULL);
//      plocale = setlocale(LC_ALL,"RU_RU");
//      pdtcnv =localdtconv();
      plocale = setlocale(LC_ALL,"RU_RU.IBM-866");

   }

   printf("ruseng\n");
   dics = new Vocab("ruseng");
   if(dics->Error)
          dics->Import("ruseng.txt","ruseng","᪮-᪨ 騩"," Nike Korolev'");

   printf(" %s,\n䠩=%s,\n਩=%s\n",dics->name, dics->fname, dics->comment);
   printf("o %s ᫥ 䨪 %s",ctime(&dics->CreationTime), ctime(&dics->LastchangeTime));

   s1 = "";

   rc = dics->Search(s1);
   printf("饬 (筮) %s ",s1);
   printf("rc=%i, err=%i\n",rc,dics->Error);

   s2 = "";
   rc = dics->Search(s2);
   printf("饬 (筮) %s ",s2);
   printf("rc=%i, err=%i\n",rc,dics->Error);
   s3 = "";
   rc = dics->Search(s3);
   printf("饬 (筮) %s ",s3);
   printf("rc=%i, err=%i\n",rc,dics->Error);

   s4 = "";
   rc = dics->Search(s4);
   printf("饬 (筮) %s ",s4);
   printf("rc=%i, err=%i\n",rc,dics->Error);
   s5 = "";
   rc = dics->Search(s5);
   printf("饬 (筮) %s ",s5);
   printf("rc=%i, err=%i\n",rc,dics->Error);
   ind = rc;
   rc = dics->GetArticle(ind, str, sizeof(str));

   printf(" %s, =%i, rc=%i\n%s\n",dics->index[ind].word, ind, rc, str);
   s6 = "樮";
   ind = dics->GetArticle(s6, str, sizeof(str));
   printf("饬 %s, 諨  %s, =%i, Error=%i\n%s\n",s6, dics->index[ind].word, ind, dics->Error, str);
   s6 = "७";
   ind = dics->GetArticle(s6, str, sizeof(str));
   printf("饬 %s, 諨  %s, =%i, Error=%i\n%s\n",s6, dics->index[ind].word, ind, dics->Error, str);

   printf("\nmain__ar\n");

   dics1 = new Vocab("main__ar");
   if(dics1->Error)
      dics1->Import0("main__ar.dwa","main__ar","-᪨ 騩"," Slovo");

   delete dics1;
   delete dics;
}

int DecodeFrom_koi8r[256]=
{
0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,
32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,
64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,
96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,
196,179,218,191,192,217,195,180,194,193,197,223,220,219,221,222,176,177,178,244,254,250,251,247,243,242,253,245,248,252,249,246,
205,186,213,241,213,201,184,183,187,212,211,200,190,189,188,198,199,204,181,240,182,185,209,210,203,207,208,202,216,215,206,255,
238,160,161,230,164,165,228,163,229,168,169,170,171,172,173,174,175,239,224,225,226,227,166,162,236,235,167,232,237,233,231,234,
158,128,129,150,132,133,148,131,149,136,137,138,139,140,141,142,143,159,144,145,146,147,134,130,156,155,135,152,157,153,151,154
};

int DecodeTo_koi8r[256];


int StrToKoi(unsigned char *str)
{ static int start=1;
  int i,l;
  if(start)
  {  start = 0;
     for(i=0;i<256;i++)
       DecodeTo_koi8r[DecodeFrom_koi8r[i]] = i;
  }
  l = strlen((char *) str);
  for(i=0;i<l;i++)
     str[i] = DecodeTo_koi8r[(int)str[i]];
}

int StrToKoi(unsigned char *str, int decodeMode)
{ static int start=1;
  int i,l,rc;

  if(start)
  {  start = 0;
     for(i=0;i<256;i++)
       DecodeTo_koi8r[DecodeFrom_koi8r[i]] = i;
  }

  l = strlen((char *) str);

     switch(decodeMode)
     {  case 1:
         for(i=0;i<l;i++)
             str[i] = DecodeTo_koi8r[(int)str[i]];
         rc = l;
          break;
       case 2:
         rc = l;
          break;
       default:
         rc = l;

     }

    return rc;
}

int StrFromKoi(unsigned  char *str)
{
   return StrFromKoi(str, 1);
}

int StrFromKoi(unsigned  char *str, int decodeMode)
{ int i,l;

  switch(decodeMode)
  {  case 1:   // from Koi8 to cp866
       l = strlen((char *) str);
       for(i=0;i<l;i++)
         str[i] = DecodeFrom_koi8r[(int)str[i]];
        break;
     case 2:   // from unicode to ??
     default:
        ;
  }

  return l;
}
/*

Thu Jan 25 15:24:36 2001
wordj=%D4%C5%D3%D4&extmode=1&wordlist=cccccc&wnX=662&wnY=400&d1=1&d2=0&button=%F0%C5%D2%C5%D7%CF%C4
Query=, 1,1 in 1, decodeMode 0
REMOTE_ADDR=195.209.192.2 REMOTE_HOST =(null)
H_USER_AGENT=Mozilla/4.61 [ru] (OS/2; I), w=662,h=400
H_ACCEPT_CHARSET =iso-8859-5,*,utf-8
H_ACCEPT_LANGUAGE =ru,en
Ok
Thu Jan 25 15:25:31 2001
wordj=%C1%C2%C9%D4%D5%D2%C9%C5%CE%D4&extmode=1&wordlist=%C1%C2%C9%D4%D5%D2%C9%C
5%CE%D4&wnX=662&wnY=400
Query=, 1,1 in , decodeMode 0
REMOTE_ADDR=195.209.192.2 REMOTE_HOST =(null)
H_USER_AGENT=Mozilla/4.61 [ru] (OS/2; I), w=662,h=400
H_ACCEPT_CHARSET =iso-8859-5,*,utf-8
H_ACCEPT_LANGUAGE =ru,en
Ok

*/

// getenv  ⫠
char *sl_getenv(char *var)
{
//const char msg0[] = "i:/apache/cgi-bin/slovar2.exe";
static char msg0[] = "i:/apache/cgi-bin/slovar2.exe";
static char msg1[] ="iso-8859-5,*,utf-8";
static char msg2[] = "ru,en"; // =ru,en-us;q=0.5
static char msg3[] = "RU_RU";

char *answ;
#if DEBUG
     if(!stricmp(var,"SCRIPT_FILENAME") )
         return (char *) msg0;
     if(!stricmp(var,"HTTP_ACCEPT_CHARSET") )
         return (char *) msg1;
     if(!stricmp(var,"HTTP_ACCEPT_LANGUAGE") )
         return (char *) msg2;
     if(!stricmp(var,"LANG") )
         return (char *) msg3;
#endif

     answ = getenv(var);
/*
   {
      FILE *fpLOG=fopen( "a2.log","a");
      fprintf(fpLOG,"%s %s \n",var, answ);

      fclose(fpLOG);

   }
*/
      return answ;


}

